/************************************************
 * Virlist Header File with program definitions *
 * Required with VIRLIST.C V1.0 source code.	*
 ************************************************/

char buffer[1024]; /* input buffer */

#define bool unsigned char

/* include complete directory for location of text file */
#define VIRLIST_FILE "virlist.txt"

#define TRUE	  1
#define FALSE	  0
#define	NOT_USED -1

enum Size_Flags { INVALID=0, LESS_THAN=1, EQUAL=2, GREATER_THAN=3,
		  OVERWRITE=-1, VARIES=-2, OTHER=-3, SPAWN=-4 };
char *size_strings[6] = { "less than", "equal to", "greater than",
			  "overwrites", "varies", "spawning" };

/* program option flags */

bool boot, data, format, links, ops, program;
long size_value; /* matching size to check */
enum Size_Flags size_code = INVALID;
int flags[10] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}; /* init flags as unset */


/* Record storing virus list entry */

struct virEntry
{
	char name[27];		/* Virus name */
	char disinfector[10];	/* Disinfecting program */
	bool codes[10]; 	/* Characteristic codes */
	long size;		/* Size of virus if appropriate */

	/* Damage codes */
	bool boot,		/* Corrupts or overwrites the boot sector */
	     data,		/* Corrupts data files */
	     format,		/* Formats or overwrites all/part of disk */
	     links,	     	/* Directly or indirectly corrupts file linkage */
	     ops,		/* Affects system run-time operation */
	     program;		/* Corrupts program or overlay files */
} virus;


#define MSG_NUM 18	/* Number of messages */

char *messages [MSG_NUM] = {
	"-------------------------------------------------------------------------",
	"B - Corrupts or overwrites the boot sector",
	"C - Corrupts program or overlay files",
	"D - Corrupts data files",
	"F - Formats or overwrites all/part of disk",
	"L - Directly or indirectly corrupts file linkage",
	"O - Affects system run-time operation",
	"P - Infects Fixed Disk Partition Table (MBR)",
	"V - Variable sized file infections",

	"1 - Virus Uses STEALTH Techniques",
	"2 - Virus Uses Self-Encryption",
	"3 - Virus Installs Self in Memory",
	"4 - Infects COMMAND.COM",
	"5 - Infects COM files",
	"6 - Infects EXE Files",
	"7 - Infects Overlay Files",
	"8 - Infects Floppy Diskette Boot",
	"9 - Infects Fixed Disk Boot Sector"
};


/* Function prototypes */

void CheckArgs(), Help(), Legend(), SkipHeader(), PrintRecord();
int GetRecord();


/* Initialization Macros for CheckArgs() */

#define SetField(FIELD, MSG_N)	FIELD = 1;\
				printf("\t%s\n", messages[MSG_N]); break

/*
#define SetFlag(FIELD, MSG_N)   flags[FIELD-1] = 1;\
				printf("\t%s\n", messages[MSG_N]); break
*/

/* Macros for GetRecord function */

#define Copy(FIELD, LEN)	strncpy(virus.FIELD, buf, LEN);\
				virus.FIELD[LEN] = 0

#define Damage(FIELD)		if (FIELD) match++;\
				virus.FIELD = 1; break
